Subject: Re: If you would write git from scratch now, what would you change?

From: Steven Walter <[email-masked]>
Date: Sun, 25 Nov 2007 20:28:37 -0500

On Sun, Nov 25, 2007 at 11:23:14PM +0100, Pierre Habouzit wrote:
> On Sun, Nov 25, 2007 at 09:48:27PM +0000, Jakub Narebski wrote:
> > If you would write git from scratch now, from the beginning, without 
> > concerns for backwards compatibility, what would you change, or what 
> > would you want to have changed?
> 
>   * reset/checkout/revert. The commands to wonderful things, but this UI
>     is a mess for the newcomer.

Heartily seconded.  I think checkout is the most egregrious of the
three.  git-checkout can be used to:

    * Switch branches
    * Create a branch
    * Change the state of all files to a particular commit
    * Change the state of a particular file to that of the index
    * Change the state of a particular file (and index) to a particular
      commit

To makes things more complicated, several of these tasks can be done
with other commands.  Short of rewriting git from scratch, what can be
done to simplify the many-to-many mapping of tasks to commands?
-- 
-Steven Walter <[email-masked]>
Freedom is the freedom to say that 2 + 2 = 4
B2F1 0ECC E605 7321 E818  7A65 FC81 9777 DC28 9E8F